package net.knarcraft.blockhunt;

import me.libraryaddict.disguise.DisguiseAPI;
import me.libraryaddict.disguise.disguisetypes.DisguiseType;
import me.libraryaddict.disguise.disguisetypes.MiscDisguise;
import net.knarcraft.blockhunt.arena.Arena;
import net.knarcraft.blockhunt.arena.ArenaHandler;
import net.knarcraft.blockhunt.arena.ArenaState;
import net.knarcraft.blockhunt.command.CreateCommand;
import net.knarcraft.blockhunt.command.HelpCommand;
import net.knarcraft.blockhunt.command.InfoCommand;
import net.knarcraft.blockhunt.command.JoinCommand;
import net.knarcraft.blockhunt.command.LeaveCommand;
import net.knarcraft.blockhunt.command.ListCommand;
import net.knarcraft.blockhunt.command.NotFoundCommand;
import net.knarcraft.blockhunt.command.ReloadCommand;
import net.knarcraft.blockhunt.command.RemoveCommand;
import net.knarcraft.blockhunt.command.SetCommand;
import net.knarcraft.blockhunt.command.SetWarpCommand;
import net.knarcraft.blockhunt.command.ShopCommand;
import net.knarcraft.blockhunt.command.StartCommand;
import net.knarcraft.blockhunt.command.TokensCommand;
import net.knarcraft.blockhunt.command.WandCommand;
import net.knarcraft.blockhunt.listener.OnBlockBreakEvent;
import net.knarcraft.blockhunt.listener.OnBlockPlaceEvent;
import net.knarcraft.blockhunt.listener.OnEntityDamageByEntityEvent;
import net.knarcraft.blockhunt.listener.OnEntityDamageEvent;
import net.knarcraft.blockhunt.listener.OnFoodLevelChangeEvent;
import net.knarcraft.blockhunt.listener.OnInventoryClickEvent;
import net.knarcraft.blockhunt.listener.OnInventoryCloseEvent;
import net.knarcraft.blockhunt.listener.OnPlayerDropItemEvent;
import net.knarcraft.blockhunt.listener.OnPlayerInteractEvent;
import net.knarcraft.blockhunt.listener.OnPlayerMoveEvent;
import net.knarcraft.blockhunt.listener.OnPlayerQuitEvent;
import net.knarcraft.blockhunt.listener.OnPlayerSwapHandItemsEvent;
import net.knarcraft.blockhunt.listener.OnPlayerTeleportEvent;
import net.knarcraft.blockhunt.listener.OnSignChangeEvent;
import net.knarcraft.blockhunt.manager.CommandManager;
import net.knarcraft.blockhunt.manager.ConfigManager;
import net.knarcraft.blockhunt.manager.MessageManager;
import net.knarcraft.blockhunt.manager.PermissionsManager;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.WordUtils;
import org.bukkit.Bukkit;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.block.data.BlockData;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.serialization.ConfigurationSerialization;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.java.JavaPlugin;
import org.jetbrains.annotations.NotNull;

import java.util.ArrayList;
import java.util.List;

public class BlockHunt extends JavaPlugin implements Listener {
    /**
     * Steffion's Engine - Made by Steffion.
     * <p>
     * You're allowed to use this engine for own usage, you're not allowed to
     * republish the engine. Using this for your own plugin is allowed when a
     * credit is placed somewhere in the plugin.
     * <p>
     * Thanks for your cooperate!
     *
     * @author Steffion
     */

    public static PluginDescriptionFile pdfFile;
    public static BlockHunt plugin;

    @SuppressWarnings("serial")
    public static final List<String> BlockHuntCMD = new ArrayList<>() {
        {
            add("info");
            add("help");
            add("reload");
            add("join");
            add("leave");
            add("list");
            add("shop");
            add("start");
            add("wand");
            add("create");
            add("set");
            add("setwarp");
            add("remove");
            add("tokens");
        }
    };

    public static CommandManager CMD;
    public static CommandManager CMDInfo;
    public static CommandManager CMDHelp;
    public static CommandManager CMDReload;
    public static CommandManager CMDJoin;
    public static CommandManager CMDLeave;
    public static CommandManager CMDList;
    public static CommandManager CMDShop;
    public static CommandManager CMDStart;
    public static CommandManager CMDWand;
    public static CommandManager CMDCreate;
    public static CommandManager CMDSet;
    public static CommandManager CMDSetWarp;
    public static CommandManager CMDRemove;
    public static CommandManager CMDTokens;

    public void onEnable() {
        getServer().getPluginManager().registerEvents(this, this);

        getServer().getPluginManager().registerEvents(new OnBlockBreakEvent(), this);
        getServer().getPluginManager().registerEvents(new OnBlockPlaceEvent(), this);
        getServer().getPluginManager().registerEvents(new OnEntityDamageByEntityEvent(), this);
        getServer().getPluginManager().registerEvents(new OnEntityDamageEvent(), this);
        getServer().getPluginManager().registerEvents(new OnFoodLevelChangeEvent(), this);
        getServer().getPluginManager().registerEvents(new OnInventoryClickEvent(), this);
        getServer().getPluginManager().registerEvents(new OnInventoryCloseEvent(), this);
        getServer().getPluginManager().registerEvents(new OnPlayerSwapHandItemsEvent(), this);

        getServer().getPluginManager().registerEvents(new OnPlayerDropItemEvent(), this);
        getServer().getPluginManager().registerEvents(new OnPlayerInteractEvent(), this);
        getServer().getPluginManager().registerEvents(new OnPlayerMoveEvent(), this);
        getServer().getPluginManager().registerEvents(new OnPlayerTeleportEvent(), this);
        getServer().getPluginManager().registerEvents(new OnPlayerQuitEvent(), this);
        getServer().getPluginManager().registerEvents(new OnSignChangeEvent(), this);

        ConfigurationSerialization.registerClass(Arena.class, "BlockHuntArena");

        pdfFile = getDescription();
        plugin = this;

        ConfigManager.newFiles();

        CMD = new CommandManager("BlockHunt", "BlockHunt", null, null, PermissionsC.Permissions.info, ConfigC.help_info, (Boolean) MemoryStorage.config.get(ConfigC.commandEnabled_info), BlockHuntCMD,
                new InfoCommand(), null);
        CMDInfo = new CommandManager("BlockHunt INFO", "BlockHunt", "info", "i", PermissionsC.Permissions.info, ConfigC.help_info, (Boolean) MemoryStorage.config.get(ConfigC.commandEnabled_info),
                BlockHuntCMD, new InfoCommand(), "/BlockHunt [info|i]");
        CMDHelp = new CommandManager("BlockHunt HELP", "BlockHunt", "help", "h", PermissionsC.Permissions.help, ConfigC.help_help, (Boolean) MemoryStorage.config.get(ConfigC.commandEnabled_help),
                BlockHuntCMD, new HelpCommand(), "/BlockHunt <help|h> [page number]");
        CMDReload = new CommandManager("BlockHunt RELOAD", "BlockHunt", "reload", "r", PermissionsC.Permissions.reload, ConfigC.help_reload,
                (Boolean) MemoryStorage.config.get(ConfigC.commandEnabled_reload), BlockHuntCMD, new ReloadCommand(), "/BlockHunt <reload|r>");
        CMDJoin = new CommandManager("BlockHunt JOIN", "BlockHunt", "join", "j", PermissionsC.Permissions.join, ConfigC.help_join, (Boolean) MemoryStorage.config.get(ConfigC.commandEnabled_join),
                BlockHuntCMD, new JoinCommand(), "/BlockHunt <join|j> <arena name>");
        CMDLeave = new CommandManager("BlockHunt LEAVE", "BlockHunt", "leave", "l", PermissionsC.Permissions.leave, ConfigC.help_leave,
                (Boolean) MemoryStorage.config.get(ConfigC.commandEnabled_leave), BlockHuntCMD, new LeaveCommand(), "/BlockHunt <leave|l>");
        CMDList = new CommandManager("BlockHunt LIST", "BlockHunt", "list", "li", PermissionsC.Permissions.list, ConfigC.help_list, (Boolean) MemoryStorage.config.get(ConfigC.commandEnabled_list),
                BlockHuntCMD, new ListCommand(), "/BlockHunt <list|li>");
        CMDShop = new CommandManager("BlockHunt SHOP", "BlockHunt", "shop", "sh", PermissionsC.Permissions.shop, ConfigC.help_shop, (Boolean) MemoryStorage.config.get(ConfigC.commandEnabled_shop),
                BlockHuntCMD, new ShopCommand(), "/BlockHunt <shop|sh>");
        CMDStart = new CommandManager("BlockHunt START", "BlockHunt", "start", "go", PermissionsC.Permissions.start, ConfigC.help_start,
                (Boolean) MemoryStorage.config.get(ConfigC.commandEnabled_start), BlockHuntCMD, new StartCommand(), "/BlockHunt <start|go> <arena name>");
        CMDWand = new CommandManager("BlockHunt WAND", "BlockHunt", "wand", "w", PermissionsC.Permissions.create, ConfigC.help_wand, (Boolean) MemoryStorage.config.get(ConfigC.commandEnabled_wand),
                BlockHuntCMD, new WandCommand(), "/BlockHunt <wand|w>");
        CMDCreate = new CommandManager("BlockHunt CREATE", "BlockHunt", "create", "c", PermissionsC.Permissions.create, ConfigC.help_create,
                (Boolean) MemoryStorage.config.get(ConfigC.commandEnabled_create), BlockHuntCMD, new CreateCommand(), "/BlockHunt <create|c> <arena name>");
        CMDSet = new CommandManager("BlockHunt SET", "BlockHunt", "set", "s", PermissionsC.Permissions.set, ConfigC.help_set, (Boolean) MemoryStorage.config.get(ConfigC.commandEnabled_set),
                BlockHuntCMD, new SetCommand(), "/BlockHunt <set|s> <arena name>");
        CMDSetWarp = new CommandManager("BlockHunt SETWARP", "BlockHunt", "setwarp", "sw", PermissionsC.Permissions.setwarp, ConfigC.help_setwarp,
                (Boolean) MemoryStorage.config.get(ConfigC.commandEnabled_setwarp), BlockHuntCMD, new SetWarpCommand(),
                "/BlockHunt <setwarp|sw> <lobby|hiders|seekers|spawn> <arena name>");
        CMDRemove = new CommandManager("BlockHunt REMOVE", "BlockHunt", "remove", "delete", PermissionsC.Permissions.remove, ConfigC.help_remove,
                (Boolean) MemoryStorage.config.get(ConfigC.commandEnabled_remove), BlockHuntCMD, new RemoveCommand(), "/BlockHunt <remove|delete> <arena name>");
        CMDTokens = new CommandManager("BlockHunt TOKENS", "BlockHunt", "tokens", "t", PermissionsC.Permissions.tokens, ConfigC.help_tokens,
                (Boolean) MemoryStorage.config.get(ConfigC.commandEnabled_tokens), BlockHuntCMD, new TokensCommand(), "/BlockHunt <tokens|t> <set|add|take> <player name> <amount>");

        if (!getServer().getPluginManager().isPluginEnabled("LibsDisguises")) {
            MessageManager.broadcastFMessage(ConfigC.error_libsDisguisesNotInstalled);
            Bukkit.getServer().getPluginManager().disablePlugin(this);
            return;
        }

        if (!getServer().getPluginManager().isPluginEnabled("ProtocolLib")) {
            MessageManager.broadcastFMessage(ConfigC.error_protocolLibNotInstalled);
            Bukkit.getServer().getPluginManager().disablePlugin(this);
            return;
        }

        ArenaHandler.loadArenas();

        MessageManager.sendFMessage(null, ConfigC.log_enabledPlugin, "name-" + BlockHunt.pdfFile.getName(), "version-" + BlockHunt.pdfFile.getVersion(), "authors-"
                + BlockHunt.pdfFile.getAuthors().get(0));

        // Welcome to the massive game loop!!
        getServer().getScheduler().runTaskTimer(this, () -> {
            for (Arena arena : MemoryStorage.arenaList) {
                if (arena.gameState == ArenaState.WAITING) {
                    if (arena.playersInArena.size() >= arena.minPlayers) {
                        arena.gameState = ArenaState.STARTING;
                        arena.timer = arena.timeInLobbyUntilStart;
                        ArenaHandler.sendFMessage(arena, ConfigC.normal_lobbyArenaIsStarting, "1-" + arena.timeInLobbyUntilStart);
                    }
                } else if (arena.gameState == ArenaState.STARTING) {
                    arena.timer = arena.timer - 1;
                    if (arena.timer > 0) {
                        if (arena.timer == 60 || arena.timer == 30 || arena.timer == 10) {
                            ArenaHandler.sendFMessage(arena, ConfigC.normal_lobbyArenaIsStarting, "1-" + arena.timer);
                        } else if (arena.timer <= 5) {
                            World world = arena.lobbyWarp.getWorld();
                            if (world != null) {
                                int pitch = (int) (2 - Math.floor(arena.timer / 2.0));
                                world.playSound(arena.lobbyWarp, Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1, pitch);
                            }
                            ArenaHandler.sendFMessage(arena, ConfigC.normal_lobbyArenaIsStarting, "1-" + arena.timer);
                        }
                    } else {
                        arena.gameState = ArenaState.IN_GAME;
                        arena.timer = arena.gameTime;
                        ArenaHandler.sendFMessage(arena, ConfigC.normal_lobbyArenaStarted, "secs-" + arena.waitingTimeSeeker);

                        for (int i = arena.amountSeekersOnStart; i > 0; i = i - 1) {
                            boolean loop = true;
                            Player seeker = arena.playersInArena.get(MemoryStorage.random.nextInt(arena.playersInArena.size()));

                            for (Player playerCheck : arena.playersInArena) {
                                if (MemoryStorage.choosenSeeker.get(playerCheck) != null) {
                                    if (MemoryStorage.choosenSeeker.get(playerCheck)) {
                                        seeker = playerCheck;
                                        MemoryStorage.choosenSeeker.remove(playerCheck);
                                    } else {
                                        if (seeker.equals(playerCheck)) {
                                            i = i + 1;
                                            loop = false;
                                        }
                                    }
                                }
                            }

                            if (loop) {
                                if (!arena.seekers.contains(seeker)) {
                                    ArenaHandler.sendFMessage(arena, ConfigC.normal_ingameSeekerChoosen, "seeker-" + seeker.getName());
                                    arena.seekers.add(seeker);
                                    PlayerHandler.teleport(seeker, arena.seekersWarp);
                                    seeker.getInventory().clear();
                                    seeker.updateInventory();
                                    seeker.setWalkSpeed(0.3F);
                                    MemoryStorage.seekertime.put(seeker, arena.waitingTimeSeeker);
                                } else {
                                    i = i + 1;
                                }
                            }
                        }

                        for (Player arenaPlayer : arena.playersInArena) {
                            if (!arena.seekers.contains(arenaPlayer)) {
                                arenaPlayer.getInventory().clear();
                                arenaPlayer.updateInventory();
                                ItemStack block = arena.disguiseBlocks.get(MemoryStorage.random.nextInt(arena.disguiseBlocks.size()));

                                if (MemoryStorage.choosenBlock.get(arenaPlayer) != null) {
                                    block = MemoryStorage.choosenBlock.get(arenaPlayer);
                                    MemoryStorage.choosenBlock.remove(arenaPlayer);
                                }

                                MiscDisguise disguise = new MiscDisguise(DisguiseType.FALLING_BLOCK, block.getType());
                                DisguiseAPI.disguiseToAll(arenaPlayer, disguise);
                                PlayerHandler.teleport(arenaPlayer, arena.hidersWarp);
                                ItemStack blockCount = new ItemStack(block.getType(), 5);
                                arenaPlayer.getInventory().setItem(8, blockCount);
                                arenaPlayer.getInventory().setHelmet(new ItemStack(block));
                                MemoryStorage.pBlock.put(arenaPlayer, block);
                                String blockName = block.getType().name();
                                blockName = WordUtils.capitalizeFully(blockName.replace("_", " "));
                                MessageManager.sendFMessage(arenaPlayer, ConfigC.normal_ingameBlock,
                                        "block-" + blockName);
                            }
                        }
                    }
                }

                for (Player player : arena.seekers) {
                    if (player.getInventory().getItem(0) == null || player.getInventory().getItem(0).getType() != Material.DIAMOND_SWORD) {
                        player.getInventory().clear(); // semi prevent duping infinite swords. TODO: Fix this properly
                        ItemStack i = new ItemStack(Material.DIAMOND_SWORD, 1);
                        i.addUnsafeEnchantment(Enchantment.DAMAGE_ALL, 10);
                        player.getInventory().setItem(0, i);
                        player.getInventory().setHelmet(new ItemStack(Material.IRON_HELMET, 1));
                        player.getInventory().setChestplate(new ItemStack(Material.IRON_CHESTPLATE, 1));
                        player.getInventory().setLeggings(new ItemStack(Material.IRON_LEGGINGS, 1));
                        player.getInventory().setBoots(new ItemStack(Material.IRON_BOOTS, 1));
                        ItemStack infBow = new ItemStack(Material.BOW, 1);
                        infBow.addEnchantment(Enchantment.ARROW_INFINITE, 1);
                        player.getInventory().setItem(1, infBow);
                        player.getInventory().setItem(2, new ItemStack(Material.ARROW, 1));
                        player.playSound(player.getLocation(), Sound.BLOCK_ANVIL_USE, 1, 1);
                    }

                    if (MemoryStorage.seekertime.get(player) != null) {
                        MemoryStorage.seekertime.put(player, MemoryStorage.seekertime.get(player) - 1);
                        if (MemoryStorage.seekertime.get(player) <= 0) {
                            PlayerHandler.teleport(player, arena.hidersWarp);
                            MemoryStorage.seekertime.remove(player);
                            ArenaHandler.sendFMessage(arena, ConfigC.normal_ingameSeekerSpawned, "playername-" + player.getName());
                        }
                    }
                }

                if (arena.gameState == ArenaState.IN_GAME) {
                    arena.timer = arena.timer - 1;
                    if (arena.timer > 0) {
                        if (arena.timer == arena.gameTime - arena.timeUntilHidersSword) {
                            ItemStack sword = new ItemStack(Material.WOODEN_SWORD, 1);
                            sword.addUnsafeEnchantment(Enchantment.KNOCKBACK, 2);
                            for (Player arenaPlayer : arena.playersInArena) {
                                if (!arena.seekers.contains(arenaPlayer)) {
                                    arenaPlayer.getInventory().addItem(sword);
                                    MessageManager.sendFMessage(arenaPlayer, ConfigC.normal_ingameGivenSword);
                                }
                            }
                        }

                        // blockAnnouncer code.
                        if ((arena.blockAnnouncerTime > 0) && (arena.timer == arena.blockAnnouncerTime)) {
                            ArrayList<String> remainingBlocks = new ArrayList<>();
                            for (Player arenaPlayer : arena.playersInArena) {
                                if (!arena.seekers.contains(arenaPlayer)) {
                                    String block = arenaPlayer.getInventory().getItem(8).getType().name();
                                    block = WordUtils.capitalizeFully(block.replace("_", " "));
                                    if (!remainingBlocks.contains(block)) { //Don't print double up block names.
                                        remainingBlocks.add(block);
                                    }
                                }
                            }
                            String blocklist = StringUtils.join(remainingBlocks, ", ");
                            ArenaHandler.sendFMessage(arena, ConfigC.normal_ingameBlocksLeft, "1-" + blocklist);
                        }

                        if (arena.timer == 190 || arena.timer == 60 || arena.timer == 30 || arena.timer == 10) {
                            ArenaHandler.sendFMessage(arena, ConfigC.normal_ingameArenaEnd, "1-" + arena.timer);
                        } else if (arena.timer <= 5) {
                            World world = arena.lobbyWarp.getWorld();
                            if (world != null) {
                                int pitch = (int) (2 - Math.floor(arena.timer / 2.0));
                                world.playSound(arena.lobbyWarp, Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1, pitch);
                            }
                            ArenaHandler.sendFMessage(arena, ConfigC.normal_lobbyArenaIsStarting, "1-" + arena.timer);
                        }
                    } else {
                        ArenaHandler.hidersWin(arena);
                        return;
                    }

                    for (Player player : arena.playersInArena) {
                        if (!arena.seekers.contains(player)) {
                            Location pLoc = player.getLocation();
                            Location moveLoc = MemoryStorage.moveLoc.get(player);
                            ItemStack block = player.getInventory().getItem(8);

                            if (block == null) {
                                if (MemoryStorage.pBlock.get(player) != null) {
                                    block = MemoryStorage.pBlock.get(player);
                                    player.getInventory().setItem(8, block);
                                    player.updateInventory();
                                }
                            }

                            if (moveLoc != null) {
                                if (moveLoc.getX() == pLoc.getX() && moveLoc.getY() == pLoc.getY() && moveLoc.getZ() == pLoc.getZ()) {
                                    if (block.getAmount() > 1) {
                                        block.setAmount(block.getAmount() - 1);
                                    } else {
                                        Block pBlock = player.getLocation().getBlock();
                                        BlockData pBlockData = pBlock.getBlockData();
                                        if (pBlockData.getMaterial().equals(Material.AIR) || pBlockData.getMaterial().equals(Material.WATER)
                                                || pBlockData.getMaterial().equals(Material.WATER)) {
                                            if (pBlockData.getMaterial().equals(Material.WATER) || pBlockData.getMaterial().equals(Material.WATER)) {
                                                MemoryStorage.hiddenLocWater.put(player, true);
                                            } else {
                                                MemoryStorage.hiddenLocWater.put(player, false);
                                            }
                                            if (DisguiseAPI.isDisguised(player)) {
                                                DisguiseAPI.undisguiseToAll(player);
                                                for (Player pl : Bukkit.getOnlinePlayers()) {
                                                    if (!pl.equals(player)) {
                                                        pl.hidePlayer(this, player);
                                                        pl.sendBlockChange(pBlock.getLocation(), block.getType().createBlockData());
                                                    }
                                                }

                                                block.addUnsafeEnchantment(Enchantment.DURABILITY, 10);
                                                player.playSound(pLoc, Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1, 1);
                                                MemoryStorage.hiddenLoc.put(player, moveLoc);
                                                String blockName = block.getType().name();
                                                blockName = WordUtils.capitalizeFully(blockName.replace("_", " "));
                                                MessageManager.sendFMessage(player, ConfigC.normal_ingameNowSolid, "block-"
                                                        + blockName);
                                            }
                                            for (Player pl : Bukkit.getOnlinePlayers()) {
                                                if (!pl.equals(player)) {
                                                    pl.hidePlayer(this, player);
                                                    pl.sendBlockChange(pBlock.getLocation(), block.getType().createBlockData());
                                                }
                                            }
                                        } else {
                                            MessageManager.sendFMessage(player, ConfigC.warning_ingameNoSolidPlace);
                                        }
                                    }
                                } else {
                                    block.setAmount(5);
                                    if (!DisguiseAPI.isDisguised(player)) {
                                        SolidBlockHandler.makePlayerUnsolid(player);
                                    }
                                }
                            }
                        }
                    }
                    ScoreboardHandler.updateScoreboard(arena); // TODO Only do this when needed (player added/removed)
                }

                for (Player pl : arena.playersInArena) {
                    pl.setLevel(arena.timer);
                    if (arena.seekers.contains(pl)) {
                        pl.setGameMode(GameMode.SURVIVAL);
                    } else {
                        pl.setGameMode(GameMode.ADVENTURE);
                    }
                }
            }
            SignsHandler.updateSigns(); //TODO Only do this when needed (game-state change or player count change)
        }, 0, 20);
    }

    public void onDisable() {
        for (Arena arena : MemoryStorage.arenaList) {
            String cause = "[BlockHunt] Arena " + arena.arenaName + " has been stopped";
            ArenaHandler.stopArena(arena, cause, ConfigC.warning_arenaStopped);
        }

        MessageManager.sendFMessage(null, ConfigC.log_disabledPlugin, "name-" + BlockHunt.pdfFile.getName(), "version-" + BlockHunt.pdfFile.getVersion(), "authors-"
                + BlockHunt.pdfFile.getAuthors().get(0));
    }

    /**
     * Args to String. Makes 1 string.
     *
     * @param input    String list which should be converted to a string.
     * @param startArg Start on this length.
     * @return The converted string.
     */
    public static String stringBuilder(String[] input, int startArg) {
        if (input.length - startArg <= 0) {
            return null;
        }
        StringBuilder sb = new StringBuilder(input[startArg]);
        for (int i = ++startArg; i < input.length; i++) {
            sb.append(' ').append(input[i]);
        }
        return sb.toString();
    }

    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command cmd, @NotNull String label, String[] args) {
        Player player = null;
        if (sender instanceof Player) {
            player = (Player) sender;
        }

        for (CommandManager command : MemoryStorage.commands) {
            String[] argsSplit = null;
            String[] argsSplitAlias = null;

            if (command.args != null && command.argsalias != null) {
                argsSplit = command.args.split("/");
                argsSplitAlias = command.argsalias.split("/");
            }

            if (cmd.getName().equalsIgnoreCase(command.label)) {
                boolean equals = true;

                if (argsSplit == null) {
                    equals = args.length == 0;
                } else {
                    if (args.length >= argsSplit.length) {
                        for (int i2 = argsSplit.length - 1; i2 >= 0; i2 = i2 - 1) {
                            int loc = argsSplit.length - i2 - 1;
                            if (!argsSplit[loc].equalsIgnoreCase(args[loc]) && !argsSplitAlias[loc].equalsIgnoreCase(args[loc])) {
                                equals = false;
                                break;
                            }
                        }
                    } else {
                        equals = false;
                    }
                }

                if (equals) {
                    if (PermissionsManager.hasPerm(player, command.permission, true)) {
                        if (command.enabled) {
                            return command.CMD.execute(player, cmd, label, args);
                        } else {
                            MessageManager.sendFMessage(player, ConfigC.error_commandNotEnabled);
                        }
                    }

                    return true;
                }
            }
        }
        new NotFoundCommand().execute(player, cmd, label, args);
        return true;
    }

    @Override
    public List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command cmd, @NotNull String label, String[] args) {

        for (CommandManager command : MemoryStorage.commands) {
            if (cmd.getName().equalsIgnoreCase(command.label)) {
                if (args.length == 1) {
                    return command.mainTABlist;
                }
            }
        }

        return null;
    }

    /**
     * Short a String for like the Scoreboard title.
     *
     * @param string    String to be shortened.
     * @param maxLength Max length of the characters.
     * @return Shorten string, else normal string.
     */
    public static String cutString(String string, int maxLength) {
        if (string.length() > maxLength) {
            string = string.substring(0, maxLength);
        }
        return string;
    }
}
