package net.knarcraft.blockhunt.command;

import net.knarcraft.blockhunt.BlockHunt;
import net.knarcraft.blockhunt.ConfigC;
import net.knarcraft.blockhunt.MemoryStorage;
import net.knarcraft.blockhunt.arena.Arena;
import net.knarcraft.blockhunt.arena.ArenaHandler;
import net.knarcraft.blockhunt.manager.MessageManager;
import org.bukkit.Location;
import org.bukkit.command.Command;
import org.bukkit.entity.Player;

public class SetWarpCommand extends DefaultCommand {

    @Override
    public boolean execute(Player player, Command cmd, String label, String[] args) {
        if (player != null) {
            if (args.length <= 2) {
                MessageManager.sendFMessage(player, ConfigC.error_notEnoughArguments, "syntax-" + BlockHunt.CMDSetWarp.usage);
            } else {
                String arenaname = args[2];
                String warpname = args[1];

                Arena arena = null;
                for (Arena arena2 : MemoryStorage.arenaList) {
                    if (arena2.arenaName.equalsIgnoreCase(arenaname)) {
                        arena = arena2;
                    }
                }
                if (arena != null) {
                    Location loc = player.getLocation();
                    if (warpname.equalsIgnoreCase("lobby")) {
                        arena.lobbyWarp = loc;
                        save(arena);
                        MessageManager.sendFMessage(player, ConfigC.normal_setwarpWarpSet, "warp-" + warpname);
                    } else if (warpname.equalsIgnoreCase("hiders")) {
                        arena.hidersWarp = loc;
                        save(arena);
                        MessageManager.sendFMessage(player, ConfigC.normal_setwarpWarpSet, "warp-" + warpname);
                    } else if (warpname.equalsIgnoreCase("seekers")) {
                        arena.seekersWarp = loc;
                        save(arena);
                        MessageManager.sendFMessage(player, ConfigC.normal_setwarpWarpSet, "warp-" + warpname);
                    } else if (warpname.equalsIgnoreCase("spawn")) {
                        arena.spawnWarp = loc;
                        save(arena);
                        MessageManager.sendFMessage(player, ConfigC.normal_setwarpWarpSet, "warp-" + warpname);
                    } else {
                        MessageManager.sendFMessage(player, ConfigC.error_setwarpWarpNotFound, "warp-" + warpname);
                    }
                } else {
                    MessageManager.sendFMessage(player, ConfigC.error_noArena, "name-" + arenaname);
                }
            }
        } else {
            MessageManager.sendFMessage(player, ConfigC.error_onlyIngame);
        }
        return true;
    }

    public void save(Arena arena) {
        MemoryStorage.arenas.getFile().set(arena.arenaName, arena);
        MemoryStorage.arenas.save();
        ArenaHandler.loadArenas();
    }
}
