package net.knarcraft.blockhunt.listener;

import net.knarcraft.blockhunt.MemoryStorage;
import net.knarcraft.blockhunt.arena.Arena;
import net.knarcraft.blockhunt.arena.ArenaHandler;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockPlaceEvent;

public class OnBlockPlaceEvent implements Listener {

    @EventHandler(priority = EventPriority.NORMAL, ignoreCancelled = true)
    public void onBlockPlaceEvent(BlockPlaceEvent event) {
        // Early exit if no one is in any arena
        if (ArenaHandler.noPlayersInArenas()) {
            return;
        }

        Player player = event.getPlayer();
        for (Arena arena : MemoryStorage.arenaList) {
            if (arena.playersInArena.contains(player)) {
                event.setCancelled(true);
            }
        }
    }
}
